Package: VegaMC
Type: Package
Title: VegaMC: A Package Implementing a Variational Piecewise Smooth
        Model for Identification of Driver Chromosomal Imbalances in
        Cancer
Version: 3.49.0
Date: 2015-03-03
Author: S. Morganella and M. Ceccarelli
Maintainer: Sandro Morganella <morganellaalx@gmail.com>
Description: This package enables the detection of driver chromosomal
        imbalances including loss of heterozygosity (LOH) from array
        comparative genomic hybridization (aCGH) data. VegaMC performs
        a joint segmentation of a dataset and uses a statistical
        framework to distinguish between driver and passenger mutation.
        VegaMC has been implemented so that it can be immediately
        integrated with the output produced by PennCNV tool. In
        addition, VegaMC produces in output two web pages that allows a
        rapid navigation between both the detected regions and the
        altered genes. In the web page that summarizes the altered
        genes, the link to the respective Ensembl gene web page is
        reported.
License: GPL-2
Depends: R (>= 2.10.0), biomaRt, Biobase
Imports: methods
LazyLoad: yes
biocViews: aCGH, CopyNumberVariation
Packaged: 2025-11-01 00:48:19 UTC; biocbuild
git_url: https://git.bioconductor.org/packages/VegaMC
git_branch: devel
git_last_commit: ad29267
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.23
Date/Publication: 2025-10-31
NeedsCompilation: yes

qvalue <-function(pval) {

lambda=seq(0,0.90,0.05);

pi0 <- rep(0,length(lambda))
       for(i in 1:length(lambda)) {
            pi0[i] <- mean(pval >= lambda[i])/(1-lambda[i]);
}
spi0 <- smooth.spline(lambda,pi0,df=3);
pi0 <- predict(spi0,x=max(lambda))$y;
pi0 <- min(pi0,1);
m <- length(pval);

u <- order(pval);
idx <- sort.list(pval);
fc <- factor(pval);
nl <- length(levels(fc));
bin <- as.integer(fc);
tbl <- tabulate(bin);
cs <- cumsum(tbl);
tbl <- rep(cs, tbl);
tbl[idx] <- tbl;

qvalue <- pi0*m*pval/tbl;
qvalue[u[m]] <- min(qvalue[u[m]],1);
for(i in (m-1):1) {
	qvalue[u[i]] <- min(qvalue[u[i]],qvalue[u[i+1]],1);
}
return (qvalue);

}

sortData <- function(dataset, output_file_name = "")
{

    if (!file.exists(dataset)) {
	message("ERROR: Specified Input File does not Exist")
	return(FALSE)
    }
    if( output_file_name == "" || 
	    substr(output_file_name, 
		nchar(output_file_name), nchar(output_file_name)) == "/" ){
        message("ERROR: You must provide the name of the file",
                " in which sorted data are saved")
	return(FALSE)
    }
    res <- .C("sort_data", as.character(dataset),
              as.character(output_file_name))
}

setGeneric("vegaMC", 
			function(dataset, output_file_name="output", beta=0.5, 
			min_region_bp_size=1000, correction=FALSE,
    	    loss_threshold=-0.2, gain_threshold=0.2, baf=TRUE,
    	    loh_threshold=0.75, loh_frequency=0.8, bs=1000,
    	    pval_threshold=0.05, html=TRUE, getGenes=TRUE,
    	    mart_database="ensembl",
    	    ensembl_dataset="hsapiens_gene_ensembl")
    	    standardGeneric("vegaMC"))

setMethod("vegaMC", "character", 
		function(dataset, output_file_name="output", 
		beta=0.5, min_region_bp_size=1000, correction=FALSE,
        loss_threshold=-0.2, gain_threshold=0.2, baf=TRUE,
        loh_threshold=0.75, loh_frequency=0.8, bs=1000,
        pval_threshold=0.05, html=TRUE, getGenes=TRUE,
        mart_database="ensembl",
        ensembl_dataset="hsapiens_gene_ensembl"){

    if(!file.exists(dataset)){
	message("ERROR: Specified Input File does not Exists")
	return(FALSE)
    }
    if( output_file_name == "" || 
	    substr(output_file_name, 
		nchar(output_file_name), nchar(output_file_name)) == "/" ){
	message("ERROR: Invalid Output File Name")
	return(FALSE)
    }
    n_samples=0
    n_probes=0
    n_chromosomes=0

    if(baf){
        baf = 1
    }else{
        baf=0
    }
    res <- .C("run_vegaMC", data=as.character(dataset),
            out=as.character(output_file_name),   
            b= as.double(beta),
            mrbs = as.integer(min_region_bp_size),
            losst = as.double(loss_threshold),
            gaint = as.double(gain_threshold),
            ba = as.integer(baf),
            loht = as.double(loh_threshold),
            lohf = as.double(loh_frequency),
            bsp = as.integer(bs),
            ns = as.integer(n_samples),
            np = as.integer(n_probes),
            nc = as.integer(n_chromosomes))

    n_samples = res$ns
    n_probes = res$np
    n_chromosomes = res$nc

    segmentation <- read.table(output_file_name, sep="\t",
                    header=TRUE, as.is=TRUE)
    segmentation <- as.matrix(segmentation)
    segmentation[which(is.nan(segmentation))] <- 0
    
    if(correction==TRUE){
	segmentation[,6] <- qvalue(as.numeric(segmentation[,6]))
	segmentation[,7] <- qvalue(as.numeric(segmentation[,7]))
	segmentation[,8] <- qvalue(as.numeric(segmentation[,8]))
    }
    segmentation[,6] <- round(as.numeric(segmentation[,6]), 5)
    segmentation[,7] <- round(as.numeric(segmentation[,7]), 5)
    segmentation[,8] <- round(as.numeric(segmentation[,8]), 5)
    

    f_l <- 
	as.numeric(segmentation[,9]) * abs(
		as.numeric(segmentation[,13]))/ as.numeric(segmentation[,12 ])
    f_g <- 
	as.numeric(segmentation[,10]) * abs(
		as.numeric(segmentation[,14]))/ as.numeric(segmentation[,12 ])
    f_loh<- 
	as.numeric(segmentation[,11]) * abs(
		as.numeric(segmentation[,15]))/ as.numeric(segmentation[,12 ])
    
    
    segmentation <- cbind(segmentation, f_l, f_g, f_loh)
    segmentation[which(is.nan(segmentation))] <- 0

    segmentation[,9] <- round(as.numeric(segmentation[,9])*100, 1)
    segmentation[,10] <- round(as.numeric(segmentation[,10])*100, 1)
    segmentation[,11] <- round(as.numeric(segmentation[,11])*100, 1)
    segmentation[,9] <- paste(as.numeric(segmentation[,9]), "%", sep="")
    segmentation[,10] <- paste(as.numeric(segmentation[,10]), "%", sep="")
    segmentation[,11] <- paste(as.numeric(segmentation[,11]), "%", sep="")
    colnames(segmentation)[12:18] <- c("Probe Size", "Loss Mean", "Gain Mean",
					"LOH Mean", "Focal-score Loss",
					"Focal-score Gain", "Focal-score LOH")
    write.table(segmentation, output_file_name, sep="\t", row.names=FALSE,
		col.names=TRUE, quote=FALSE, eol="\n")
   

    ## Creating the html file
    if(html==TRUE || getGenes==TRUE){
        js_file <- system.file("scripts/sorttable.js", package="VegaMC")
        logo <- system.file("template/image/bioinfologo.png",
                        package="VegaMC")
        ens <- system.file("template/image/ensemblicon.gif",
                        package="VegaMC")
        ## Get the output directory from output_file_name argument
        tmp_str <- unlist(strsplit(output_file_name, split=""))
        pos <- which(tmp_str=="/")
        if(length(pos)==0){
        file.copy(js_file, ".")
        file.copy(logo, ".")
        if(getGenes==TRUE){
            file.copy(ens, ".")
        }
    }else{
        file.copy(js_file, substr(output_file_name, 1,
                pos[length(pos)]))
        file.copy(logo, substr(output_file_name, 1,
                pos[length(pos)]))
        if(getGenes==TRUE){
            file.copy(ens, substr(output_file_name, 1,
                pos[length(pos)]))
        }
    }
       
       
    }

    if(html==TRUE){
        message("Creating HTML file '", paste(output_file_name,
                            ".html", sep=""), "'")
        createHTML(paste(output_file_name, ".html", sep=""), segmentation,
                pval_threshold, loss_threshold, gain_threshold,
                loh_frequency, loh_threshold, baf, n_samples,
                n_probes, 1:n_chromosomes, beta, min_region_bp_size,
                bs, getGenes, correction)
        message("Done\n")
    }

    if(getGenes==TRUE){
        message("Creating Gene Summary HTML file '",
        paste(output_file_name, "Genes.html", sep=""),"'")
        getGenes(paste(output_file_name, "Genes.html", sep=""),
                segmentation, pval_threshold, baf, ensembl_dataset,
                mart_database, html, correction)
        message("\nDone")
    }
    return(segmentation)   

}
)

getGenes <-
function(out_file_name, segmentation, pval_threshold, baf, ensembl_dataset,
        mart_database, html, correction){
## This function generates the html file reporting the list
## (with the respective details) of each gene overlapping a significant region

    eps <- 0.00000001;
    message("Connecting to BioMart \"", mart_database, "\" Database")
    if(mart_database=="ensembl"){
        ensembl <- useMart(mart_database, dataset=ensembl_dataset)
    }else{
        ensembl <- useMart(mart_database, archive=TRUE,
                dataset=ensembl_dataset)
    }
    ensembl_url <- "http://www.ensembl.org/Gene/Summary?g="

    del_genes <- matrix(nrow=0, ncol=12)
    amp_genes <- matrix(nrow=0, ncol=12)
    if(baf==TRUE){
        loh_genes <- matrix(nrow=0, ncol=12)
    }

    message("Downloading Gene Information from \"", ensembl_dataset,
        "\" Database")
    chromosomes <- sort(unique(segmentation[,1]))
    for(chr in chromosomes){
        message(".", appendLF = FALSE)
        curr_seg <- segmentation[which(as.character(segmentation[,1])
                        ==as.character(chr)),]
        if(class(curr_seg)!="matrix"){
            curr_seg <- t(as.matrix(curr_seg))
        }
        for(j in 1:nrow(curr_seg)){
            curr_reg <- curr_seg[j,]
            if(min(c(as.numeric(curr_reg[6]),as.numeric(curr_reg[7]),
            as.numeric(curr_reg[8])))<=pval_threshold){

                genes_details <- getBM(attributes=c("ensembl_gene_id",
                        "external_gene_id", "chromosome_name",
                        "start_position", "end_position",
                        "band",    "strand", "description"),
                        filters=c("chromosome_name", "start", "end"),
                        values=list(curr_reg[1], curr_reg[2], curr_reg[3]),
                        mart=ensembl)
               
                if(nrow(genes_details)>0){
                    if(as.numeric(curr_reg[6])<=pval_threshold){
                        new <- cbind(genes_details,
			    round(as.numeric(curr_reg[6]),5), curr_reg[9], 
			    as.numeric(curr_reg[13]),
			    round(as.numeric(curr_reg[16]),5)
			    )
                        del_genes <- rbind(del_genes, new)
                    }
                    if(as.numeric(curr_reg[7])<=pval_threshold){
                        new <- cbind(genes_details,
			    round(as.numeric(curr_reg[7]),5), curr_reg[10], 
			    as.numeric(curr_reg[14]),
			    round(as.numeric(curr_reg[17]),5)
			    )
                        amp_genes <- rbind(amp_genes, new)
                    }
                    if(baf==TRUE && as.numeric(curr_reg[8])<=pval_threshold){
                        new <- cbind(genes_details,
			    round(as.numeric(curr_reg[8]),5), curr_reg[11], 
			    as.numeric(curr_reg[15]),
			    round(as.numeric(curr_reg[18]),5)
			    )
                        loh_genes <- rbind(loh_genes, new)
                    }
                }
            }
        }
    }

    colnames(del_genes) <- c("Ensembl Gene ID", "External Gene ID",
			     "Chromosome", "Gene Start", "Gene End", "Cytoband",
			     "Strand",  "Description", "p-val", "Frequency",
			     "Mean", "Focal Score")
    delfile <- paste(substr(out_file_name, 1, nchar(out_file_name)-5),
		    "DelGenes", sep="")
   
    ## Matrix containing the set of genes overlapping lost regions
    del_genes[,1] <- paste("<a href=\"", ensembl_url, del_genes[,1], "\">",
                del_genes[,1] ,"</a>", sep="")
    del_genes[,4:5] <- format(del_genes[,4:5], big.mark=".")
    

    colnames(amp_genes) <- c("Ensembl Gene ID", "External Gene ID",
			     "Chromosome", "Gene Start", "Gene End", "Cytoband",
			     "Strand",  "Description", "p-val", "Frequency",
			     "Mean", "Focal Score")
    ampfile <- paste(substr(out_file_name, 1, nchar(out_file_name)-5),
		    "AmpGenes", sep="")
   
    ## Matrix containing the set of genes overlapping amplified regions
    amp_genes[,1] <- paste("<a href=\"", ensembl_url, amp_genes[,1], "\">",
                amp_genes[,1] ,"</a>", sep="")
    amp_genes[,4:5] <- format(amp_genes[,4:5], big.mark=".")
  

    ## Matrix containing the set of genes overlapping LOH regions
    if(baf==TRUE){
	colnames(loh_genes) <- c("Ensembl Gene ID", "External Gene ID",
			     "Chromosome", "Gene Start", "Gene End", "Cytoband",
			     "Strand",  "Description", "p-val", "Frequency",
			     "Mean", "Focal Score")
	lohfile <- paste(substr(out_file_name, 1, nchar(out_file_name)-5),
		    "LOHGenes", sep="")
	
        loh_genes[,1] <- paste("<a href=\"", ensembl_url, loh_genes[,1], "\">",
                loh_genes[,1] ,"</a>", sep="")
        loh_genes[,4:5] <- format(loh_genes[,4:5], big.mark=".")
       
    }

    ## Create the Header
    inFile <- system.file("template/HeaderGenes.html", package="VegaMC")
    inFile <- file(inFile, "r")
    outFile <- file(out_file_name, "w")
    index=""
    if(html==TRUE){
        html_genes <- paste(substr(out_file_name, 1, nchar(out_file_name)-10),
                ".html", sep="")
    }
    values <- c(TITLE=out_file_name, DATE=date(), REGFILE=html_genes)
    values <- c(values, NDEL=nrow(del_genes))
    values <- c(values, NAMP=nrow(amp_genes))
    if(baf==TRUE){
        values <- c(values, NLOH=nrow(loh_genes))
    }else{
        values <- c(values, NLOH="NA")
    }
    copySubstitute(inFile, outFile, values)
    close(inFile)

   
    if(nrow(del_genes)>0){
	del_genes <- as.matrix(del_genes)
	uniq_gene <- unique(del_genes[,1])
	## There are duplicate genes
	if(length(uniq_gene) != nrow(del_genes)){
	    for(i in 1:length(uniq_gene)){
		pos <- which(del_genes[,1]==uniq_gene[i])
		if(length(pos)>1){
		    pv <- round(min(as.numeric(del_genes[pos,9]))+eps, 5)
		    del_genes[pos[1],9] <- pv
				
		    fr <- as.character(del_genes[pos,10])
		    fr <- substr(fr, 1, nchar(fr)-1)
		    del_genes[pos[1],10] <- 
			paste(round(max(as.numeric(fr)), 1), "%", sep="")

		    m <- round(mean(as.numeric(del_genes[pos,11]))+eps, 5)
		    del_genes[pos[1],11] <- m
				
		    fs <- round(mean(as.numeric(del_genes[pos,12]))+eps, 5)
		    del_genes[pos[1],12] <- fs
		
		    del_genes <- del_genes[-pos[2:length(pos)],]
		}
		
	    }
	}

	del_genes <-
	    del_genes[order(as.numeric(substr(del_genes[,10], 1,
	    nchar(del_genes[,10])-1)), decreasing=TRUE),]
	
	 write.table(del_genes, delfile, sep="\t", col.names=TRUE,
		row.names=FALSE, eol="\n", quote=FALSE) 

	del_genes[,c(9,11,12)] <-
	format(round(as.numeric(del_genes[,c(9,11,12)]), 5), decimal.mark=",")
	
	
	## Create the Header for the Table of Deleted Genes
        inFile <- system.file("template/HeaderTableAberrantGenes.html",
                    package="VegaMC")
        inFile <- file(inFile, "r")
        values <- c(values, TABNAME="Deleted", ABERR="Loss")
	if(correction==TRUE){
	    values <- c(values, SIGN="q")
	}else{
	    values <- c(values, SIGN="p")
	}
        copySubstitute(inFile, outFile, values)
        close(inFile)
        ## Insert a new Line for each Gene
        for(i in 1:nrow(del_genes)){
	    inFile <- system.file("template/AberrantGeneTableRow.html",
		    package="VegaMC")
	    inFile <- file(inFile, "r")
	    values <- c(ENSID=as.character(del_genes[i,1]))
	    values <- c(values, GENEID=as.character(del_genes[i,2]))
	    values <- c(values, CHR=as.character(del_genes[i,3]))
	    values <- c(values, BPSTART=as.character(del_genes[i,4]))   
	    values <- c(values, BPEND=as.character(del_genes[i,5]))
	    if(is.na(del_genes[i,6])){
		values <- c(values, CYTO="")
	    }else{
		values <- c(values, CYTO=as.character(del_genes[i,6]))
	    }
	    if(is.na(del_genes[i,7])){
		values <- c(values, STRAND="")
	    }else{
		values <- c(values, STRAND=as.character(del_genes[i,7]))
	    }
	    if(is.na(del_genes[i,8])){
		values <- c(values, DESCR="")
	    }else{
		values <- c(values, DESCR=as.character(del_genes[i,8]))
	    }
	    values <- c(values, ABERRPVAL=as.character(del_genes[i,9]))
	    values <- c(values, ABERRPRC=as.character(del_genes[i,10]))
	    values <- c(values, MEAN=as.character(del_genes[i,11]))
	    values <- c(values, FOC=as.character(del_genes[i,12]))
	    copySubstitute(inFile, outFile, values)
	    close(inFile)   
        }
        ## Create the Footer for the Table of Deleted Genes
        inFile <- system.file("template/FooterTable.html", package="VegaMC")
        inFile <- file(inFile, "r")
        values <- c(values, VAL="NO")
        copySubstitute(inFile, outFile, values)
        close(inFile)
    }
  
    if(nrow(amp_genes)>0){
        amp_genes <- as.matrix(amp_genes)
	uniq_gene <- unique(amp_genes[,1])
	## There are duplicate genes
	if(length(uniq_gene) != nrow(amp_genes)){
	    for(i in 1:length(uniq_gene)){
		pos <- which(amp_genes[,1]==uniq_gene[i])
		if(length(pos)>1){
		    pv <- round(min(as.numeric(amp_genes[pos,9]))+eps, 5)
		    amp_genes[pos[1],9] <- pv
				
		    fr <- as.character(amp_genes[pos,10])
		    fr <- substr(fr, 1, nchar(fr)-1)
		    amp_genes[pos[1],10] <- 
			paste(round(max(as.numeric(fr)), 1), "%", sep="")

		    m <- round(mean(as.numeric(amp_genes[pos,11]))+eps, 5)
		    amp_genes[pos[1],11] <- m
				
		    fs <- round(mean(as.numeric(amp_genes[pos,12]))+eps, 5)
		    amp_genes[pos[1],12] <- fs
		
		    amp_genes <- amp_genes[-pos[2:length(pos)],]
		}
		
	    }
	}

	amp_genes <-
	    amp_genes[order(as.numeric(substr(amp_genes[,10], 1,
	    nchar(amp_genes[,10])-1)), decreasing=TRUE),]

	 write.table(amp_genes, ampfile, sep="\t", col.names=TRUE, 
		row.names=FALSE, eol="\n", quote=FALSE) 

	amp_genes[,c(9,11,12)] <-
	format(round(as.numeric(amp_genes[,c(9,11,12)]), 5), decimal.mark=",")
        ## Create the Header for the Table of Amplified Genes
        inFile <- system.file("template/HeaderTableAberrantGenes.html",
                package="VegaMC")
        inFile <- file(inFile, "r")
        values <- c(values, TABNAME="Amplified", ABERR="Gain")
	if(correction==TRUE){
	    values <- c(values, SIGN="q")
	}else{
	    values <- c(values, SIGN="p")
	}
        copySubstitute(inFile, outFile, values)
        close(inFile)
	
        ## Insert a new Line for each Gene
        for(i in 1:nrow(amp_genes)){
        inFile <- system.file("template/AberrantGeneTableRow.html",
                package="VegaMC")
        inFile <- file(inFile, "r")
        values <- c(ENSID=as.character(amp_genes[i,1]))
        values <- c(values, GENEID=as.character(amp_genes[i,2]))
        values <- c(values, CHR=as.character(amp_genes[i,3]))
        values <- c(values, BPSTART=as.character(amp_genes[i,4]))   
        values <- c(values, BPEND=as.character(amp_genes[i,5]))
        if(is.na(amp_genes[i,6])){
            values <- c(values, CYTO="")
        }else{
            values <- c(values, CYTO=as.character(amp_genes[i,6]))
        }
        if(is.na(amp_genes[i,7])){
            values <- c(values, STRAND="")
        }else{
            values <- c(values, STRAND=as.character(amp_genes[i,7]))
        }
        if(is.na(amp_genes[i,8])){
            values <- c(values, DESCR="")
        }else{
            values <- c(values, DESCR=as.character(amp_genes[i,8]))
        }
        values <- c(values, ABERRPVAL=as.character(amp_genes[i,9]))
        values <- c(values, ABERRPRC=as.character(amp_genes[i,10]))
	values <- c(values, MEAN=as.character(amp_genes[i,11]))
	values <- c(values, FOC=as.character(amp_genes[i,12]))
        copySubstitute(inFile, outFile, values)
        close(inFile)   
        }
        ## Create the Footer for the Table of Amplified Genes
        inFile <- system.file("template/FooterTable.html", package="VegaMC")
        inFile <- file(inFile, "r")
        values <- c(values, VAL="NO")
        copySubstitute(inFile, outFile, values)
        close(inFile)
    }
    
    if(baf==TRUE){
        if(nrow(loh_genes)>0){
            loh_genes <- as.matrix(loh_genes)
	    loh_gene <- unique(loh_genes[,1])
	    ## There are duplicate genes
	    if(length(uniq_gene) != nrow(loh_genes)){
		for(i in 1:length(uniq_gene)){
		pos <- which(loh_genes[,1]==uniq_gene[i])
		if(length(pos)>1){
		    pv <- round(min(as.numeric(loh_genes[pos,9]))+eps, 5)
		    loh_genes[pos[1],9] <- pv
				
		    fr <- as.character(loh_genes[pos,10])
		    fr <- substr(fr, 1, nchar(fr)-1)
		    loh_genes[pos[1],10] <- 
			paste(round(max(as.numeric(fr)), 1), "%", sep="")

		    m <- round(mean(as.numeric(loh_genes[pos,11]))+eps, 5)
		    loh_genes[pos[1],11] <- m
				
		    fs <- round(mean(as.numeric(loh_genes[pos,12]))+eps, 5)
		    loh_genes[pos[1],12] <- fs
		
		    loh_genes <- loh_genes[-pos[2:length(pos)],]
		}
		
	    }
	    }

	    loh_genes <-
		loh_genes[order(as.numeric(substr(loh_genes[,10], 1,
			    nchar(loh_genes[,10])-1)), decreasing=TRUE),]

	    write.table(loh_genes, lohfile, sep="\t", col.names=TRUE, 
                    row.names=FALSE, eol="\n", quote=FALSE) 

	    loh_genes[,c(9,11,12)] <-
	format(round(as.numeric(loh_genes[,c(9,11,12)]), 5), decimal.mark=",")
            ## Create the Header for the Table of LOH Genes
            inFile <- system.file("template/HeaderTableAberrantGenes.html",
                    package="VegaMC")
            inFile <- file(inFile, "r")
            values <- c(values, TABNAME="LOH", ABERR="LOH")
	    if(correction==TRUE){
		values <- c(values, SIGN="q")
	    }else{
		values <- c(values, SIGN="p")
	    }
            copySubstitute(inFile, outFile, values)
            close(inFile)

            ## Insert a new Line for each Gene
            for(i in 1:nrow(loh_genes)){
                inFile <- system.file("template/AberrantGeneTableRow.html",
                    package="VegaMC")
                inFile <- file(inFile, "r")
                values <- c(ENSID=as.character(loh_genes[i,1]))
                values <- c(values, GENEID=as.character(loh_genes[i,2]))
                values <- c(values, CHR=as.character(loh_genes[i,3]))
                values <- c(values, BPSTART=as.character(loh_genes[i,4]))   
                values <- c(values, BPEND=as.character(loh_genes[i,5]))
                if(is.na(loh_genes[i,6])){
                    values <- c(values, CYTO="")
                }else{
                    values <- c(values, CYTO=as.character(loh_genes[i,6]))
                }
                if(is.na(loh_genes[i,7])){
                    values <- c(values, STRAND="")
                }else{
                    values <- c(values, STRAND=as.character(loh_genes[i,7]))
                }
                if(is.na(loh_genes[i,8])){
                    values <- c(values, DESCR="")
                }else{
                    values <- c(values, DESCR=as.character(loh_genes[i,8]))
                }
                values <- c(values, ABERRPVAL=as.character(loh_genes[i,9]))
                values <- c(values, ABERRPRC=as.character(loh_genes[i,10]))
		values <- c(values, MEAN=as.character(loh_genes[i,11]))
		values <- c(values, FOC=as.character(loh_genes[i,12]))
                copySubstitute(inFile, outFile, values)
                close(inFile)   
            }
            ## Create the Footer for the Table of LOH Genes
            inFile <- system.file("template/FooterTable.html",
                    package="VegaMC")
            inFile <- file(inFile, "r")
            values <- c(values, VAL="NO")
            copySubstitute(inFile, outFile, values)
            close(inFile)
        }
    }

    ## Create the Footer
    inFile <- system.file("template/Footer.html", package="VegaMC")
    inFile <- file(inFile, "r")
    values <- c(BIOINFO="http://bioinformatics.biogem.it")
    copySubstitute(inFile, outFile, values)
    close(inFile)
    close(outFile)

}

createHTML <-
function(output_file_name, segmentation, pval_threshold, loss_threshold,
        gain_threshold, loh_percentage, loh_threshold, baf, n_samples,
        n_probes, chromosomes, beta, min_region_bp_size,
        bs, getGenes, correction){
## This function generates the html file reporting the list
## (with the respective details) of each detected region

    ## check if BAFs are observed
    if(baf==TRUE){
        print_baf <- "YES"
    }else{
        print_baf <- "NO"
    }

    n_reg <- nrow(segmentation)
    loss_pos <- which(as.numeric(segmentation[,6])<=pval_threshold)
    n_loss <- length(loss_pos)
    gain_pos <- which(as.numeric(segmentation[,7])<=pval_threshold)
    n_gain <- length(gain_pos)
    n_loh = "No Available"
    if(baf==TRUE){
	loh_pos <- which(as.numeric(segmentation[,8])<=pval_threshold)
        n_loh <- length(loh_pos)
    }

    ## Create the Header
    inFile <- system.file("template/HeaderRegions.html", package="VegaMC")
    inFile <- file(inFile, "r")
    outFile <- file(output_file_name, "w")
    html_genes=""
    if(getGenes == TRUE){
        html_genes <- paste(substr(output_file_name, 1,
                nchar(output_file_name)-5), "Genes.html", sep="")
    }
    values <- c(TITLE=output_file_name, DATE=date(), GENEFILE=html_genes)
    copySubstitute(inFile, outFile, values)
    close(inFile)


    ## Create the Summary
    inFile <- system.file("template/InputParameters.html",
                package="VegaMC")
    inFile <- file(inFile, "r")
    minBP = "No"
    if(is.na(min_region_bp_size)==FALSE){
            minBP=paste(format(min_region_bp_size,
                        big.mark="."), "bp")
    }
    values <- c(NUMSAMPLE=format(n_samples, big.mark="."))
    values <- c(values, NUMCHR=length(chromosomes))
    values <- c(values, NUMPROBE=format(n_probes, big.mark="."),
                        BAF=print_baf)
    values <- c(values, BETA=format(beta, decimal.mark=","))
    values <- c(values, MINBP=minBP)
    values <- c(values, LOSST=format(loss_threshold, decimal.mark=","))
    values <- c(values, GAINT=format(gain_threshold, decimal.mark=","))
    values <- c(values, LOHT=format(loh_threshold, decimal.mark=","))
    values <- c(values, LOHP=paste(format(as.integer(loh_percentage*100),
                        decimal.mark=","),"%"))
    values <- c(values, BS=format(bs, big.mark="."))
    values <- c(values, PVAL=format(pval_threshold, scientific=TRUE))
    values <- c(values, NUMREG=format(n_reg, big.mark="."))
    values <- c(values, NUMDEL=format(n_loss, big.mark="."))
    values <- c(values, NUMAMP=format(n_gain, big.mark="."))
    if(baf==TRUE){
        values <- c(values, NUMLOH=format(n_loh, big.mark="."))
    }else{
        values <- c(values, NUMLOH=n_loh)
    }
    if(correction==TRUE){
	values <- c(values, SIGN="q")
    }else{
	values <- c(values, SIGN="p")
    }
    copySubstitute(inFile, outFile, values)
    close(inFile)


    ## Create the Header for the Table of all Regions
    inFile <- system.file("template/HeaderTableAllRegions.html",
                package="VegaMC")
    inFile <- file(inFile, "r")
    values <- c(values, VAL="NO")
    if(correction==TRUE){
	values <- c(values, SIGN="q")
    }else{
	values <- c(values, SIGN="p")
    }
    copySubstitute(inFile, outFile, values)
    close(inFile)

    ## Insert a new Line for each region
    segmentation[,2:4] <- format(as.integer(segmentation[,2:4]),
                    big.mark=".")
    segmentation[,c(5,13:15)] <- format(as.numeric(segmentation[,c(5,13:15)]),
                    decimal.mark=",")
   
    segmentation[,6:8] <- format(round(as.numeric(segmentation[,6:8]), 5),
				decimal.mark=",")
    segmentation[,16:18] <- format(round(as.numeric(segmentation[,16:18]), 5),
				decimal.mark=",")
    for(i in 1:n_reg){
        inFile <- system.file("template/AllRegionTableRow.html",
                    package="VegaMC")
        inFile <- file(inFile, "r")
        values <- c()
        values <- c(CHR=as.character(segmentation[i,1]))
        values <- c(values, BPSTART=as.character(segmentation[i,2]))
        values <- c(values, BPEND=as.character(segmentation[i,3]))
        values <- c(values, BPSIZE=as.character(segmentation[i,4]))   
        values <- c(values, L2MEAN=as.character(segmentation[i,5]))   
        values <- c(values, LOSSPVAL=as.character(segmentation[i,6]))
        values <- c(values, LOSSPRC=as.character(segmentation[i,9]))
        values <- c(values, GAINPVAL=as.character(segmentation[i,7]))
        values <- c(values, GAINPRC=as.character(segmentation[i,10]))
        values <- c(values, LOHPVAL=as.character(segmentation[i,8]))   
        values <- c(values, LOHPRC=as.character(segmentation[i,11]))
        copySubstitute(inFile, outFile, values)
        close(inFile)
    }

    ## Create the Footer for the Table of all Regions
    inFile <- system.file("template/FooterTable.html", package="VegaMC")
    inFile <- file(inFile, "r")
    values <- c(values, VAL="NO")
    copySubstitute(inFile, outFile, values)
    close(inFile)

    if(length(loss_pos)>0){
	tmp <- segmentation[loss_pos,]
	tmp <- tmp[order(as.numeric(substr(tmp[,9], 1, nchar(tmp[,9])-1)),
		    decreasing=TRUE),]
        ## Create the Header for the Table of Deleted Regions
        inFile <- system.file("template/HeaderTableAberrantRegions.html",
                    package="VegaMC")
        inFile <- file(inFile, "r")
        values <- c(values, TABNAME="Deleted", ABERR="Loss")
	if(correction==TRUE){
	    values <- c(values, SIGN="q")
	}else{
	    values <- c(values, SIGN="p")
	}
        copySubstitute(inFile, outFile, values)
        close(inFile)
        ## Insert a new Line for each region
        for(i in 1:length(loss_pos)){
            inFile <- system.file(
                    "template/AberrantRegionTableRow.html",
                    package="VegaMC")
            inFile <- file(inFile, "r")
            values <- c()
            values <- c(CHR=as.character(tmp[i,1]))
            values <- c(values,
                    BPSTART=as.character(tmp[i,2]))
            values <- c(values,
                    BPEND=as.character(tmp[i,3]))
            values <- c(values,
                    BPSIZE=as.character(tmp[i,4]))   
            values <- c(values,
                    L2MEAN=as.character(tmp[i,13]))   
            values <- c(values,
                    ABERRPVAL=as.character(tmp[i,6]))
            values <- c(values,
                    ABERRPRC=as.character(tmp[i,9]))
	    values <- c(values,
                    FOC=as.character(tmp[i,16]))
            copySubstitute(inFile, outFile, values)
            close(inFile)
        }
        ## Create the Footer for the Table of Deleted Regions
        inFile <- system.file("template/FooterTable.html",
                    package="VegaMC")
        inFile <- file(inFile, "r")
        values <- c(values, VAL="NO")
        copySubstitute(inFile, outFile, values)
        close(inFile)
    }

    if(length(gain_pos)>0){
	tmp <- segmentation[gain_pos,]
	tmp <- tmp[order(as.numeric(substr(tmp[,10], 1, nchar(tmp[,10])-1)),
		    decreasing=TRUE),]
        ## Create the Header for the Table of Amplified Regions
        inFile <- system.file("template/HeaderTableAberrantRegions.html",
                    package="VegaMC")
        inFile <- file(inFile, "r")
        values <- c(values, TABNAME="Amplified", ABERR="Gain")
	if(correction==TRUE){
	    values <- c(values, SIGN="q")
	}else{
	    values <- c(values, SIGN="p")
	}
        copySubstitute(inFile, outFile, values)
        close(inFile)
        ## Insert a new Line for each region
        for(i in 1:length(gain_pos)){
            inFile <- system.file(
                    "template/AberrantRegionTableRow.html",
                    package="VegaMC")
            inFile <- file(inFile, "r")
            values <- c()
            values <- c(CHR=as.character(tmp[i,1]))
            values <- c(values,
                    BPSTART=as.character(tmp[i,2]))
            values <- c(values,
                    BPEND=as.character(tmp[i,3]))
            values <- c(values,
                    BPSIZE=as.character(tmp[i,4]))   
            values <- c(values,
                    L2MEAN=as.character(tmp[i,14]))   
            values <- c(values,
                    ABERRPVAL=as.character(tmp[i,7]))
            values <- c(values,
                    ABERRPRC=as.character(tmp[i,10]))
	    values <- c(values,
                    FOC=as.character(tmp[i,17]))
            copySubstitute(inFile, outFile, values)
            close(inFile)
        }
        ## Create the Footer for the Table of Amplified Regions
        inFile <- system.file("template/FooterTable.html",
                    package="VegaMC")
        inFile <- file(inFile, "r")
        values <- c(values, VAL="NO")
        copySubstitute(inFile, outFile, values)
        close(inFile)
    }

    if(baf==TRUE){
        if(length(loh_pos)>0){
	    tmp <- segmentation[loh_pos,]
	    tmp <- tmp[order(as.numeric(substr(tmp[,11], 1, nchar(tmp[,11])-1)),
			decreasing=TRUE),]
            inFile <- system.file(
                    "template/HeaderTableAberrantRegions.html",
                    package="VegaMC")
            inFile <- file(inFile, "r")
            values <- c(values, TABNAME="LOH", ABERR="LOH")
	    if(correction==TRUE){
		values <- c(values, SIGN="q")
	    }else{
		values <- c(values, SIGN="p")
	    }
            copySubstitute(inFile, outFile, values)
            close(inFile)
            for(i in 1:length(loh_pos)){
                inFile <- system.file(
                    "template/AberrantRegionTableRow.html",
                    package="VegaMC")
                inFile <- file(inFile, "r")
                values <- c()
                values <- c(CHR=as.character(tmp[i,1]))
                values <- c(values,
                    BPSTART=as.character(tmp[i,2]))
                values <- c(values,
                    BPEND=as.character(tmp[i,3]))
                values <- c(values,
                    BPSIZE=as.character(tmp[i,4]))   
                values <- c(values,
                    L2MEAN=as.character(tmp[i,15]))   
                values <- c(values,
                    ABERRPVAL=as.character(tmp[i,8]))
                values <- c(values,
                    ABERRPRC=as.character(tmp[i,11]))
		values <- c(values,
                    FOC=as.character(tmp[i,18]))
                copySubstitute(inFile, outFile, values)
                close(inFile)
            }
            ## Create the Footer for the Table of Amplified Regions
            inFile <- system.file("template/FooterTable.html",
                        package="VegaMC")
            inFile <- file(inFile, "r")
            values <- c(values, VAL="NO")
            copySubstitute(inFile, outFile, values)
            close(inFile)
        }
    }
    ## Create the Footer
    inFile <- system.file("template/Footer.html", package="VegaMC")
    inFile <- file(inFile, "r")
    values <- c(BIOINFO="http://bioinformatics.biogem.it")
    copySubstitute(inFile, outFile, values)
    close(inFile)
    close(outFile)
}

%\VignetteIndexEntry{VegaMC}
%\VignetteDepends{}
%\VignetteKeywords{CGH Analysis}
%\VignettePackage{VegaMC}
\documentclass[a4paper,10pt]{article}



\usepackage{graphicx}
\usepackage{enumerate}
\renewcommand{\labelitemi}{$\diamond$}

\usepackage[colorlinks=true]{hyperref}
\hypersetup{
bookmarksnumbered=true,
linkcolor=black,
citecolor=black,
pagecolor=black,
urlcolor=black,
}

%opening
\title{VegaMC: A Package Implementing a Variational Piecewise Smooth Model
for Identification of Driver Chromosomal Imbalances in Cancer}

\author{Sandro Morganella \and Michele Ceccarelli}

\date{}
\usepackage{Sweave}
\begin{document}

\maketitle

\tableofcontents

\section{Overview}
VegaMC enables the detection of driver chromosomal imbalances (deletion,
amplification and loss of heterozygosity (LOH)) from array comparative
genomic hybridization (aCGH) data. VegaMC performs a joint segmentation of
aCGH data coming from a cohort of disease affected patients. Segmented
regions are used into a statistical framework to distinguish between driver
and passenger mutations. In this way, significant imbalances can be
detected by the associated $p$-values. A very interesting feature of
VegaMC, is that, it has been implemented to be easily integrated with the
output produced by PennCNV tool \cite{PennCNV}. PennCNV is a widely used
tool in Bioinformatics, it analyzes raw files and produces for each probe
the respective value of Log R Ratio (LRR) and B Allele Frequency (BAF). In
addition, VegaMC produces in output two web pages allowing a rapid
navigation between both detected regions and altered genes. In the
web page that summarizes the altered genes, the user finds the link to the
respective Ensembl gene web page. An accurate implementation of the
algorithm allows the accurate and rapid detection of significant
chromosomal imbalances.\newline\newline
Below we lists the main interesting features of VegaMC:
\begin{itemize}
\item Designed to be integrated within PennCNV protocol
\item Detection of LOH alterations
\item Two web pages enable an easily and rapid navigation of both detected
regions and altered genes
\item Accurate analysis of large datasets in a short time
\end{itemize}

For More details
on the usage of VegaMC visit the home page of the package:\newline

\url{http://bioinformatics.biogem.it/download/vegamc/vegamc}


\section{Installation and Dependencies}
In order to install VegaMC from Bioconductor repository start R and enter:

\begin{verbatim}

> if (!requireNamespace("BiocManager", quietly=TRUE))
    > install.packages("BiocManager")
> BiocManager::install("VegaMC")
\end{verbatim}

You can load all functions of VegaMC by entering:

<<library_VegaMC>>=
library(VegaMC)
@

In order to download gene information, VegaMC need of biomaRt that
provides an interface to BioMart databases (e.g. Ensembl, COSMIC ,Wormbase
and Gramene). In addition VegaMC is compatible with the genoset package
that offers an extension of the Bioconductor {\ttfamily
eSet} object for genome arrays.

\section{Input Data Format}
The main input of VegaMC is the dataset file that has a row for each probe.
The first three columns of the file specify:
\begin{itemize}
\item The probe name
\item The chromosome in which the probe is located
\item The genomic position of the probe
\end{itemize}


The other columns of the matrix report the LRRs observed for the probe (and
optionally the BAFs). \textbf{Note that this format reflects the format of
PennCNV}. An example of input file can be found in {\ttfamily
inst/template} folder (breast\_Affy500K.txt).

\begin{center}
\begin{table}[h]

\begin{tabular}{|p{12cm}|}
\hline
\textbf{Note that the probes must be ordered by the respective genomic
positions within the chromosome. In some cases (as for PennCNV) data are
not sorted. VegaMC provides a function that performs this sorting:
{\ttfamily sortData} (see Section \ref{gist}).}\\\hline
\end{tabular}
\end{table}
\end{center}

In VegaMC the user can find an example dataset (breast\_Affy500K.txt)
composed of 10 breast tumor aCGH samples profiled by high-resolution
Affymetrix 500K Mapping Array (GEO accession GSE7545) \cite{Dataset}. Raw
data were  preprocessed in accord to PennCNV protocol and both LRR and BAF
were obtained. For space requirements only the observation for the first 4
chromosomes are reported, the complete dataset is available at:\newline

\url{http://bioinformatics.biogem.it/download/vegamc/vegamc}
\newline\newline

In order to copy the example dataset in the current work directory enter:

<<copy_dataset>>=
file.copy(system.file("example/breast_Affy500K.txt",
    package="VegaMC"),".")
@

\begin{center}
\begin{table}[h]

\begin{tabular}{|p{12cm}|}
\hline
\textbf{Note that LRR and BAF of a sample must be reported in this order:
LRR followed by BAF. breast\_Affy500K.txt agrees with this format.}\\\hline
\end{tabular}
\end{table}
\end{center}


\section{VegaMC}
VegaMC analysis is composed by three different steps: segmentation of the
dataset, classification of the regions, assessment of statistical
significance for each region. In the next sections all steps are
described providing also a description of their main specific input
parameters.


\subsection{Segmentation}
VegaMC performs a joint segmentation of all samples to detect the regions
that have a similar LRR profile among the samples. In order to perform this
joint segmentation, VegaMC extends an algorithm based on a
popular variational model \cite{Morganella2010}. In particular, VegaMC
implements the weighted multi-channel version of this model. Segmentation
is separately performed on each chromosome and results are strictly related
to the so called scale parameter: as the scale grows the segmentation
gets coarser. In VegaMC a data-driven approach is used to compute the
optimal scale value: VegaMC computes the jump of the scale required to
merge two adjacent regions (parameter {\ttfamily beta} of VegaMC). if the
allowed jump ({\ttfamily beta}) is $0$ then the computed segmentation will
be composed of $N$ regions (each region will contain just a probe). In
contrast, if the allowed jump is very large (ideally $\infty$) then the
segmentation will contain just a region for each chromosome.


\subsection{Classification}
Aim of classification step is the labeling of each detected region. For
each detected region and for each sample, classification looks for
deletions, amplifications and LOHs (if BAF is observed). This step is
performed by a threshold-based approach.


\subsubsection{Classification of Deletions and Amplifications}
In order to distinguish between deleted and amplified regions, two
thresholds are used. Given the region $i$ of the sample $j$ then:
\begin{itemize}
\item the region is considered as a deletion
if$\vert\vert\mu_{ij}\vert\vert<$ {\ttfamily loss\_threshold}
\item the region
is considered as an amplification if $\vert\vert\mu_{ij}\vert\vert>$
{\ttfamily gain\_threshold}
\end{itemize}
where
$\vert\vert\mu_{ij}\vert\vert$ is the respective mean.


\subsubsection{Classification of LOHs}
LOH is receiving greater attention as a mechanism of possible tumor
initiation. LOH is located in region with no copy number alteration
(LRR$=0$) and it is characterized by a BAF trend that moves away from the
value of $0.5$ corresponding to heterozygous genotype AB.\newline\newline
In order to detect LOH regions, two parameters are used:
\begin{itemize}
\item {\ttfamily loh\_threshold}: BAF values out of the range:\newline
$]${\ttfamily loh\_threshold},$(1-${\ttfamily loh\_threshold}$)[$ \newline
are considered to belong to homozygous genotypes AA and BB.
\item {\ttfamily loh\_frequency}: Minimum fraction of homozygous genotypes
needed for marking a region as LOH.
\end{itemize}
In other words, given the region $i$ of the sample $j$, the region is
considered to be a LOH if:
\begin{equation}
\big( \sum_{ij}
(BAF)\notin~]\mbox{{\ttfamily loh\_threshold}},(1-\mbox{{\ttfamily
loh\_threshold}})[~~\big) > \mbox{{\ttfamily loh\_frequency}}
\end{equation}
\begin{center}
\begin{table}[h]

\begin{tabular}{|p{12cm}|}
\hline
\textbf{Note that in order to detect LOHs, the dataset must contain the BAF
associated to each observed probe. This is the case of the
example file in /{\ttfamily inst/template} folder
breast\_Affy500K.txt}\\\hline
\end{tabular}
\end{table}
\end{center}



\subsection{Assessment of Statistical Significance}
The main problem in identification of chromosomal imbalances is the
distinction between driver and passenger mutations. Driver alterations are
functionally related to the disease under study, while, passenger
alterations are subject-specific random somatic mutations. Aim of this step
is the computation of the $p$-value associated to each segmented region,
which provides the evidence for driver mutations. VegaMC assigns a
$p$-value to each possible aberration: loss (deletion), gain
(amplification) and LOH. Here we use an approach similar to the one
described in \cite{Morganella2011}. Starting from a discretized
representation of the data obtained by the classification step, VegaMC
performs a conservative permutation test to obtain the null distribution
associated to the hypothesis: \textit{All observed aberrations are
passengers}.



\section{VegaMC: Run Analysis}
In order to perform the analysis, the user needs to call only the
function {\ttfamily vegaMC}. Below, the list of the input argument of this
function are listed:

\begin{itemize}
\item {\ttfamily dataset}: The file containing the observations for dataset
under inspection. The first three columns describe the name, the chromosome
and the position respectively. The other columns of the matrix report the
LRR and the BAF (if available) of each sample.


\item {\ttfamily
output\_file\_name}: (Default {\ttfamily output}) The file name used to
save the results.

\item {\ttfamily
beta}: (Default $0.5$) This parameter is used in the segmentation step to
compute the stop condition. This parameter specifies the maximum jump
allowed for the updating of the scale parameter. If {\ttfamily beta}=$0$
then the computed segmentation will be composed of a region for each probe
(all regions will contain just a probe). In contrast, if {\ttfamily
beta}$\rightarrow\infty$) then the segmentation will contain just a region
for each chromosome.

\item {\ttfamily min\_region\_bp\_size}: (Default $1000$) VegaMC
does not report the regions short then this size (in bp). Note that this is
only an output parameter, indeed, VegaMC also uses the \lq\lq
short\rq\rq~regions in all
algorithmic steps.

\item {\ttfamily classification} : (Default {\ttfamily FALSE}) If this
value is TRUE multiple testing corrections is performed.

\item {\ttfamily loss\_threshold}: (Default $-0.2$) Value used to mark a
region as a deletion (loss). If the wighted mean of a region
$\vert\vert\mu_{ij}\vert\vert$ is lower than this threshold, then the
region is marked as a deletion (loss).

\item {\ttfamily loss\_threshold}: (Default $0.2$) Value used to mark a
region as an amplification (gain). If the wighted mean of a region
$\vert\vert\mu_{ij}\vert\vert$ is greater than this threshold, then the
region is marked as an amplification (gain).

\item {\ttfamily baf} : (Default {\ttfamily TRUE}) This parameter specifies
if the dataset also contains BAF measurements. {\ttfamily baf}={\ttfamily
TRUE} means that BAF measurements are available, in this case VegaMC is
able to compute LOH imbalances. If {\ttfamily baf}={\ttfamily FALSE} the
dataset only contains the LRR values and LOH detection is not possible.

\item {\ttfamily loh\_threshold} : (Default $0.75$) Threshold used to
distinguish between homozygous and heterozygous genotypes. If the BAF is
greater than {\ttfamily loh\_threshold} or lower then ($1-${\ttfamily
loh\_threshold}) then the respective probe is considered to be homozygous.

\item {\ttfamily loh\_frequency} : (Default $0.8$) Minimum fraction of
homozygous probes needed for marking a region as LOHs. Regions with a
fraction of homozygous probes greater than this threshold are marked as
LOH.

\item {\ttfamily bs} : (Default $1000$) Number of permutation bootstraps
performed to compute the null distribution.

\item {\ttfamily pval\_threshold} : (Default $0.05$) Significance level
used to reject the null hypothesis. If the $p$-value of an aberration
(loss, gain, LOH) is not greater than this threshold, then the region is
considered to be significant and, consequently, it is considered a driver
mutation.

\item {\ttfamily html} : (Default {\ttfamily TRUE}) If this value is
{\ttfamily TRUE}, then in output will be produced an html file called
{\ttfamily output\_file\_name}.html in which a summary of all detected
regions is reported.

\item {\ttfamily getGenes} : (Default {\ttfamily TRUE}) If this value is
{\ttfamily TRUE}, then in output will be produced an html file called
{\ttfamily output\_file\_name}Genes.html in which the list of all genes
overlapping the significant regions is reported.

\item{\ttfamily mart\_database}{(Default {\ttfamily ensembl}) BioMart
database name you want to connect to. Possible database names can be
retrieved
with the function listMarts of biomaRt package.}


\item {\ttfamily ensembl\_dataset} : (Default {\ttfamily
hsapiens\_gene\_ensembl}) BioMart dataset used to get information from
Ensembl BioMart database.
\end{itemize}

The following command performs the analysis on the breast dataset with
default parameter settings:
\begin{verbatim}
> results <-
+ vegaMC("breast_Affy500K.txt",
+         output_file_name="breast.analysis.default");
\end{verbatim}

The next command
performs the analysis with the following user-defined parameter setting:
\begin{itemize}
\item Increasing
of the jump for the update of the scale parameter ({\ttfamily beta}) from
default value of $0.5$ to $1$
\item Removing
regions shorter than $2000$ bp ({\ttfamily min\_region\_pb\_size})
\item Increasing the number of permutation bootstraps  ({\ttfamily bs})
from the default value of $1000$ to $5000$
\item Generation of html pages disabled
\end{itemize}


<<runVegaMC_breast, results=hide, keep.source=TRUE>>=
results <-
vegaMC("breast_Affy500K.txt",
	output_file_name="breast.analysis",
	beta=1,	min_region_bp_size=2000, bs=5000,
	html=FALSE, getGenes=FALSE)
@


\paragraph{Output}
The function {\ttfamily vegaMC} returns a matrix with a row for each
detected region. In addition this command also creates in the current
folder the tab delimited file breast.analysis.default (reporting the matrix
content of the matrix {\ttfamily results}), the html file
breast.analysis.default.html (which provides both a summary of the input
parameter setting and all detected regions) and the html file file
breast.analysis.defaultGenes.html (which lists the genes overlapping the
significant regions).


\subsection{VegaMC: View Results}
After the execution of the previous command, the object {\ttfamily results}
contains all information on the detected regions. This object is a matrix
having a row for each detected regions. The name of the columns can be
displayed by using the following command:

<<colnames_results, results=hide>>=
colnames(results)
@

\begin{itemize}
\item {\ttfamily
Chromosome}: The chromosome of the region
\item {\ttfamily
bp Start}: The position in which the region starts (in bp)
\item {\ttfamily
bp End}: The position in which the region ends (in bp)
\item {\ttfamily
Region Size}: The size of the region (in bp)
\item {\ttfamily
Mean}: The weighted mean $\vert\vert\mu_{ij}\vert\vert$  of the
region
\item {\ttfamily
Loss p-value}: The $p$-value associated to the probability to have a driver
deletion
\item {\ttfamily
Gain p-value}: The $p$-value associated to the probability to have a driver
amplification
\item {\ttfamily
LOH p-value}: The $p$-value associated to the probability to have a driver
LOH
\item {\ttfamily
\% Loss}: The percentage of sample showing a deletion for this region
\item {\ttfamily
\% Gain}: The percentage of sample showing an amplification for this region
\item {\ttfamily
\% LOH}: The percentage of sample showing a LOH for this region
\item{\ttfamily Probe Size}: The number of probes composing the region
\item{\ttfamily Loss Mean}:Mean of LRR computed only on the samples that
show a loss
\item{\ttfamily Gain Mean}: Mean of LRR computed only on the samples that
show a gain
\item{\ttfamily LOH Mean}: Mean of LRR computed only on the samples that
show a LOH
\item{\ttfamily Focal-score Loss}: Focal Score associated to deletion
\item{\ttfamily Focal-score Gain}:Focal Score associated to amplification
\item{\ttfamily Focal-score LOH}: Focal Score associated to LOH
\end{itemize}

This matrix is automatically saved in the current work directory as a tab
delimited file. For default the name used to save the file is {\ttfamily
output}.

In addition, VegaMC creates two html pages that can be visualized by a web
browser. These web pages are created to provide a rapid and easy access to
the produced results. For default, generation of html page is active and
the file {\ttfamily output}.html and are {\ttfamily output}Genes.html are
created in the current work directory. These pages are created when options
{\ttfamily} html {\ttfamily getGenes} are {\ttfamily TRUE} (default
values).


\paragraph{output.html Web Page} This page reports a summary of the
analysis and it is composed of several sections that can be easily
navigated by using the link on the top of the page. The first section is
\textbf{Summary of Input Parameters}, it contains the parameter setting
used for the analysis. The second section is \textbf{Results Summary}, it
reports the number of identified regions and the number of each specific
mutation. The third section is \textbf{List of All Regions} in which the
information contained in the matrix {\ttfamily results} are summarized.
The next sections report the list of significant regions detected for each
imbalances (deletion, amplification and LOH). Therefore, in each section we
only find the regions that have a $p$-value lower than the specified
threshold ($0.05$ for default). Tables can be sorted by column.


\paragraph{outputGenes.html Web Page} This page shows all genes located
into a significant region. For each gene a set of information is reported.
The \textbf{Ensembl Gene ID} and the \textbf{External Gene ID} report the
name of gene. By clicking on the Ensembl Gene ID the user is automatically
redirected on the Ensembl web page of the gene. The genomic position of the
gene and the respective \textbf{Strand} and \textbf{Cytoband} are also
reported. In addition the table also contains a column with a description
of the gene (if available in Ensembl BioMart database). The last column
reports the $p$-value associated to the region overlapping the gene. Tables
can sorted by column.


\section{Analysis of Gastrointestinal Stromal Tumors (GIST) Dataset}
\label{gist}
From the home page of VegaMC you can download a tab delimited file
(gist.lrr\_baf.txt) containing LRR and BAF for the dataset
GISTs:\newline\newline

\url{http://bioinformatics.biogem.it/download/vegamc/vegamc}
\newline\newline
GISTs data were published in \cite{Astolfi2010} where 25 fresh tissue
specimens of GISTs were collected and hybridized by Affymetrix Genome Wide
SNP 6.0 (GEO identifier GSE20710). Raw data were preprocessed by PennCNV
tool and the available file is the output of PennCNV which contains
observation for $\sim 1.6$ million of probes.

The file produced by PennCNV is not sorted by the genomic position of the
probe. VegaMC provides a function that sort the data.
The function {\ttfamily sortData} takes in input a matrix and returns the
matrix ordered by the genomic position. The arguments of this function
follow:
\begin{itemize}
\item {\ttfamily
dataset}: The matrix that have to be ordered
\item {\ttfamily
output\_file\_name}: The name used to save the results into a tab
delimited file
\end{itemize}


Given that {\ttfamily gist} data is directly produced by PennCNV, default
parameter setting can be used::
\begin{verbatim}
> sortData("gist.txt", "gist.sorted.txt")
\end{verbatim}


Now we are ready to run VegaMC. The following command performs a
segmentation in which each segmented region must contain at least $5$
probes and the resulting list of
regions contains only the regions having size greater than $1000$ bp:
\begin{verbatim}
> gist.results <-
+     vegaMC("gist.sorted.txt",
+             output_file_name="gist.analysis.default",
+             min_region_bp_size=1000)
\end{verbatim}
Execution time of
VegaMC on gist dataset is about $10$ minutes. This execution time is very
interesting, given that gist dataset is not a toy example ($\sim 1.6$
million of probes on each of the 25 samples). Execution time was measured
on a Mac OS X with 4GB of RAM and CPU2$\times$2.8 GHz Quad-Core Intel Xeon.



\begin{thebibliography}{}


\bibitem{PennCNV}
PennCNV: A free software tool for Copy Number Variation (CNV) detection
from SNP genotyping arrays.
\url{http://www.openbioinformatics.org/penncnv}.

\bibitem{Dataset}
Haverty PM. {\it et~al}. (2008). High-resolution genomic and expression
analyses of copy number alterations in breast tumors. \textit{Genes
Chromosomes Cancer} \textbf{47}(6):530-542.


\bibitem{Morganella2010} Morganella S. {\it et~al}. (2010).VEGA:
Variational segmentation for copy number detection. \textit{Bioinformatics}
\textbf{26}(24):3020-3027.


\bibitem{Morganella2011} Morganella S. {\it et~al}. (2011). Finding
recurrent copy number alterations preserving within-sample homogeneity.
\textit{Bioinformatics} \textbf{27}(21):2949-2956.


\bibitem{Astolfi2010} Astolfi A. {\it et~al}. (2010). Molecular portrait of
gastrointestinal stromal tumors: an integrative analysis of gene expression
profiling and high-resolution genomic copy number. \textit{Laboratory
Investigation} \textbf{90}(9):1285-1294.


\end{thebibliography}
\end{document}

\name{vegaMC-methods}
\docType{methods}
\alias{vegaMC}
\alias{vegaMC-methods}
\alias{vegaMC,character-method}
\alias{vegaMC}
\title{
    Class aggregator of VegaMC.
}

\description{
    VegaMC enables the detection of driver chromosomal imbalances 
    (deletions, amplifications and loss of heterozygosities (LOHs)) from 
    array comparative genomic hybridization (aCGH) data. VegaMC performs 
    a joint segmentation of aCGH data. Segmented regions are then used 
    into a statistical framework to distinguish between driver and 
    passenger mutations. In this way, significant imbalances can be 
    detected by the associated p-value. VegaMC has been implemented to be 
    easily integrated with the output produced by PennCNV and with the Genoset 
    eSet Objects. VegaMC produces in output two web pages allowing a rapid 
    navigation between both detected regions and altered genes. In the web page 
    summarizing the altered genes, the user finds the link to the respective 
    Ensembl gene web page.
}
\usage{
    vegaMC(dataset, output_file_name="output", beta=0.5, 
    min_region_bp_size=1000, correction=FALSE, 
    loss_threshold=-0.2, gain_threshold=0.2, 
    baf=TRUE, loh_threshold=0.75, loh_frequency=0.8, bs=1000, 
    pval_threshold=0.05, html=TRUE, getGenes=TRUE, 
    mart_database="ensembl", ensembl_dataset="hsapiens_gene_ensembl")
}

\section{Methods}{
	\describe{
		\item{\code{signature(dataset = "character")}}{
			This method allows to run VegaMC on a data file in PennCNV format. 
		}

		\item{\code{signature(dataset = "GenoSet")}}{
			This method allows to run VegaMC on a GenoSet object of 
			\code{genoset} package. 
		}
	}
}

\arguments{

    \item{dataset}{Dataset file following the PennCNV format: The first three columns 
    describe the name, the chromosome and the position respectively. 
    The other columns of the matrix report the LRR and the BAF 
    (if available) of each sample. Note that observations must be ordered by the
    respective genomic position.}

    \item{output_file_name}{(Default code{output}) File name used 
    to save the results.}

    \item{beta}{(Default 0.5) This parameter is used to compute the 
    stop condition. It is used to calculate the maximum jump allowed in 
    scale parameter updating. If \code{beta}=0 then the resulting 
    segmentation will be composed of a region for each probe (all regions 
    will contain just a probe). In contrast, if \code{beta} is very large, 
    then the segmentation will contain just a region for each chromosome.}

    \item{min_region_bp_size}{(Default 1000) VegaMC deletes from the list 
    the regions shorter then this size (in bp).}

    \item{correction}{(Default FALSE) If this parameter is TRUE multiple 
    testing corrections is performed.}

    \item{loss_threshold}{(Default -0.2) Values used to mark a region as a 
    deletion (loss). If the wighted mean of a region is lower than this 
    threshold, then the region is marked as a deletion (loss).}

    \item{gain_threshold}{(Default 0.2) Values used to mark a region as an 
    amplification (gain). If the wighted mean of a region is greater than 
    this threshold, then the region is marked as an amplification (gain).}

    \item{baf}{(Default \code{TRUE}) This parameter specifies if the 
    dataset contains BAF measurements (default \code{TRUE}. If BAF is 
    available, then VegaMC is able to compute LOH imbalances.}

    \item{loh_threshold}{(Default 0.75) Threshold used to distinguish 
    between homozygous and heterozygous genotypes. If the BAF is greater 
    than \code{loh_threshold} or lower then (1-\code{loh_threshold}) 
    then the respective probe is considered to be homozygous.}

    \item{loh_frequency}{(Default 0.8) Minimum fraction of homozygous 
    probes needed for marking a region as LOHs. Regions with a fraction 
    of homozygous probes greater than this threshold are marked as LOH.}

    \item{bs}{(Default 1000) Number of permutation bootstraps performed 
    to compute the null distribution.}

    \item{pval_threshold}{(Default 0.05) Significance level used to 
    reject the null hypothesis. If the p-value of an aberration 
    (loss, gain, LOH) is not greater than this threshold, then the region 
    is considered to be significant and, consequently, it is considered a 
    driver mutation.}

    \item{html}{(Default \code{TRUE}) If this value is \code{TRUE}, then 
    in output will be produced an html file called 
    \code{output_file_name}.html in which a summary of all detected regions 
    is reported.}

    \item{getGenes}{(Default \code{TRUE}) If this value is \code{TRUE}, 
    then in output will be produced an html file called 
    \code{output_file_name}Genes.html in which the list of all genes 
    overlapping the significant regions is reported.}

    \item{mart_database}{(Default \code{ensembl}) BioMart database name 
    you want to connect to. Possible database names can be retrieved 
    with the function listMarts of biomaRt package.}

    \item{ensembl_dataset}{(Default \code{hsapiens_gene_ensembl}) BioMart 
    dataset used to get information from Ensembl BioMart database. 
    In order to obtain the list of all available dataset use the command 
    \code{listDatasets} of biomaRt package.}
}


\value{
    After the execution of this function, a matrix containing all 
    information on the detected regions is returned. This object is a 
    matrix having a row for each detected regions described by the 
    following columns:

    \item{Chromosome}{The chromosome in which the region is located.}
    \item{bp Start}{The position in which the region starts (in bp).}
    \item{bp End}{The position in which the region ends (in bp).}
    \item{Region Size}{The size of the regions (in bp).}
    \item{Mean}{The weighted mean of the region computed on all samples.}
    \item{Loss p-value}{The p-value associated to the probability to have 
    a driver deletion.}
    \item{Gain p-value}{The p-value associated to the probability to have 
    a driver amplification.}
    \item{LOH p-value}{The p-value associated to the probability to have 
    a driver LOH.}
    \item{\% Loss}{The percentage of samples showing a deletion for this 
    region.}
    \item{\% Gain}{The percentage of samples showing an amplification for 
    this region.}
    \item{\% LOH}{The percentage of samples showing a LOH for this region.}
    \item{Probe Size}{The number of probes composing the region.}
    \item{Loss Mean}{Mean of LRR computed only on the samples that show a loss.}
    \item{Gain Mean}{Mean of LRR computed only on the samples that show a gain.}
    \item{LOH Mean}{Mean of LRR computed only on the samples that show a LOH.}
    \item{Focal-score Loss}{Focal Score associated to deletion.}
    \item{Focal-score Gain}{Focal Score associated to amplification.}
    \item{Focal-score LOH}{Focal Score associated to LOH.}
    This matrix is automatically saved in the current work directory as a 
    tab delimited file. For default the name used to asave the file is 
    'output'.
}
\keyword{methods}
\references{
    Morganella S., and Ceccarelli M. VegaMC: a R/bioconductor package for fast downstream analysis of large array comparative genomic hybridization datasets. Bioinformatics, 28(19):2512-4 (2012).
}

\author{
    Sandro Morganella
}
\examples{
    ## Run VegaMC 
    file.copy(system.file("example/breast_Affy500K.txt", package="VegaMC"), ".")
    results <- vegaMC("breast_Affy500K.txt", "results", html=FALSE, 
                        getGenes=FALSE)
                                      
}

\name{sortData}

\alias{sortData}

\title{
    This function sorts a dataset file by the genomic position of the probes.
}

\description{
    This function sorts a dataset file by the genomic position of the probes. 
    This function makes very easy the integration of VegaMC with the output of 
    PennCNV tool.
}

\usage{
    sortData(dataset, output_file_name = "")
}

\arguments{
    \item{dataset}{Dataset file.}
    \item{output_file_name}{Name of the file in which sorted data are stored.}
}

\value{
    This function returns the input matrix ordered by the genomic
    position of the probes.
}

\references{
    Morganella S., and Ceccarelli M. VegaMC: a R/bioconductor package for fast downstream analysis of large array comparative genomic hybridization datasets. Bioinformatics, 28(19):2512-4 (2012).
}

\author{
    Sandro Morganella
}

\note{
    This function allows to sort a dataset by the genomic position. The input file
    must have the chromosome and the position in column two and three respectively.
    This format follows the standard output of PennCNV. An example of file can be 
    found in inst/example folder.
}
\examples{

    ## Copy the example dataset in current folder
    file.copy(system.file("example/breast_Affy500K.txt", package="VegaMC"), 
                            ".")


    ## Sort data and save results in sorted.txt file
    sortData("breast_Affy500K.txt", "sorted.txt");

}

\name{VegaMC-package}

\alias{VegaMC-package}

\alias{VegaMC}

\docType{package}

\title{
    VegaMC: A Package Implementing a Variational Piecewise Smooth Model for 
    Identification of Driver Chromosomal Imbalances in Cancer.
}

\description{
    VegaMC enables the detection of driver chromosomal imbalances 
    (deletions, amplifications and loss of heterozygosities (LOHs)) from 
    array comparative genomic hybridization (aCGH) data. VegaMC performs 
    a joint segmentation of aCGH data. Segmented regions are then used 
    into a statistical framework to distinguish between driver and 
    passenger mutations. In this way, significant imbalances can be 
    detected by the associated p-value. VegaMC has been implemented to be 
    easily integrated with the output produced by PennCNV. VegaMC produces 
    in output two web pages allowing a rapid navigation between both 
    detected regions and altered genes. In the web page summarizing the 
    altered genes, the user finds the link to the respective Ensembl gene
    web page.
}

\details{
    \tabular{ll}{
        Package: \tab VegaMC\cr
        Type: \tab Package\cr
        Version: \tab 3.9.3\cr
        License: \tab GPL-2\cr
        LazyLoad: \tab yes\cr
    }
}

\examples{
    ## Copy the example dataset in current folder
    file.copy(system.file("example/breast_Affy500K.txt", package="VegaMC"), 
                            ".")

    ## Analyse data and save results in sorted.txt file
    results <- vegaMC("breast_Affy500K.txt", "results", html=FALSE, 
                        getGenes=FALSE)
}
